import createDecorator from '@loafer/core/util/decorators/createDecorator';
import InjectableDefinition from '@loafer/context/definition/InjectableDefinition';
import { getInjectableDefinition } from '@loafer/context/util/metadata';
import { PouchScope } from '@loafer/pouches/constants';

const Scope = (scope: PouchScope = PouchScope.SINGLETON) => createDecorator('Scope', {
  classDecorator: <TFunction extends Function>(target: TFunction): TFunction | void => {
    let injectableDefinition = getInjectableDefinition(target.prototype, false);
    if (undefined === injectableDefinition) {
      throw new Error('Cannot apply @Scope decorator on the not @Injectable or @Injectable stereotype class.');
    }
    injectableDefinition.Scope = scope;
    return target;
  },
});

export default Scope;
