import { DESIGN_RETURNTYPE } from '@loafer/core/constants';
import InjectableDefinition from '@loafer/context/definition/InjectableDefinition';
import PouchConfig from '@loafer/context/decorator/PouchConfig';

class ConfigurationDefinition extends InjectableDefinition {
  protected _qualifier: string | symbol = undefined;
  protected _pouchMap: Map<string, PouchConfig>;

  public constructor(type: Object) {
    super(type);
  }

  public addPouch(propertyKey: string, pouchConfig: PouchConfig): void {
    if (undefined === this._pouchMap) {
      this._pouchMap = new Map();
    }
    let returnType: any = Reflect.getMetadata(DESIGN_RETURNTYPE, this._type, propertyKey);

    if (undefined === pouchConfig.type) {
      pouchConfig.type = returnType;
    }

    this._pouchMap.set(propertyKey, pouchConfig);
  }

  public get Pouches(): Map<string, PouchConfig> {
      return this._pouchMap;
  }

}

export default ConfigurationDefinition;
