import {
  Construtorable,
} from '@loafer/core/constants';

import AppContext from '@loafer/context/AppContext';

import DefaultPouchFactory from '@loafer/pouches/factory/implement/DefaultPouchFactory';

class DefaultAppContext implements AppContext {
  private readonly pouchFactory: DefaultPouchFactory;

  public constructor() {
    this.pouchFactory = new DefaultPouchFactory();
  }

  public getPouchFactory(): DefaultPouchFactory {
    return this.pouchFactory;
  }

  public getPouch<T>(type: Construtorable<T>, ...args: any[]): T {
    return this.pouchFactory.getPouch(type, args);
  }

  public getPouchByQualifier<T>(type: Construtorable<T>, qualifier: string | symbol, ...args: any[]): T {
    return this.pouchFactory.getPouchByQualifier(type, qualifier, args);
  }

}

export default DefaultAppContext;
