import InjectDefinition from '@loafer/pouches/definition/InjectDefinition';
import createDecorator from '@loafer/core/util/decorators/createDecorator';
import { getInjectDefinition } from '@loafer/pouches/util/metadata';

const Value = (value: string) => createDecorator('Value', {
  propertyDecorator: (target: Object, propertyKey: string | symbol): void => {
    let injectDefinition: InjectDefinition = getInjectDefinition(target, true);
    injectDefinition.addValue(value, propertyKey);
  },
  parameterDecorator: (target: Object, propertyKey: string | symbol, parameterIndex: number): void => {
    let injectDefinition: InjectDefinition = getInjectDefinition(target, true);
    injectDefinition.addValue(value, propertyKey, parameterIndex);
  },

});

export default Value;
