import {
  Construtorable,
  DecoratorType,
} from '@loafer/core/constants';

import {
  PouchScope,
  DEFAULT_QUALIFIER,
} from '@loafer/pouches/constants';

import PouchFactory from '@loafer/pouches/factory/PouchFactory';
import AbstractPouchFactory from '@loafer/pouches/factory/implement/AbstractPouchFactory';
import PouchDefinition from '@loafer/pouches/factory/config/PouchDefinition';
import PouchDefinitionRegistry from '@loafer/pouches/factory/registry/PouchDefinitionRegistry';

class DefaultPouchFactory extends AbstractPouchFactory implements PouchFactory, PouchDefinitionRegistry {
  public constructor() {
    super();
  }

  public getPouch<T>(type: Construtorable<T>, ...args: any[]): T {
    let qualifier = DEFAULT_QUALIFIER;
    return this.getPouchByQualifier(type, qualifier, args);
  }

  public getPouchByQualifier<T>(type: Construtorable<T>, qualifier: string | symbol, ...args: any[]): T {
    let clazz: Function = type.prototype;
    let instance: T;
    return instance;
  }


}

export default DefaultPouchFactory;
